--********** Grid *************--
local Grid = {}

local Gridmt = { __index = Grid }

function newGrid(w,h,start_x,start_y)

	local grid = setmetatable(
		{
		steps = {0, 8, 16, 32, 64, 128},
		x=0,
		y=0,
		nr=3,
		start_x=start_x or 0,
		start_y=start_y or 0,
		w=w,
		h=h,
		},
    Gridmt
	)
	return grid
end

function Grid:snap(x,y)

	if self.steps[self.nr] == 0 then
		return x, y
	end
	self.x = x - math.fmod(x - self.start_x, self.steps[self.nr])
	self.y = y - math.fmod(y - self.start_y, self.steps[self.nr])

	self.x = math.floor( x / self.steps[self.nr] ) * self.steps[self.nr]
	
	return self.x, self.y
end


function Grid:up()
	self.nr = self.nr + 1
	
	if self.nr >= #self.steps+1 then 
		self.nr = 1
	end
end

function Grid:down()
	self.nr = self.nr - 1
	
	if self.nr <= 0 then 
		self.nr = #self.steps
	end
end

function Grid:getSize()
	if self.steps[self.nr] == 0 then
		return self.steps[2] + math.random(self.steps[#self.steps]-self.steps[2])
	else
		return self.steps[self.nr]
	end
end


function Grid:draw(w,h)
	love.graphics.setColor(255,255,255, 64)
	
		if self.steps[self.nr] == 0 then
	
	else

		for x = self.start_x, self.w, self.steps[self.nr] do
			love.graphics.line( x, self.start_y, x, self.h )
		end

		for y = self.start_y, self.h , self.steps[self.nr] do
			love.graphics.line( self.start_x, y, self.w , y )
		end
	end
end