require 'libs/LUBE'
require 'libs/TSerial'
require 'libs/imageloader'
--require 'libs/object'
require 'libs/grid'


players = {}
dataToSend = {}
objects = {}
nr_objects = 0


function beginContact(a, b, coll)
local x,y = coll:getNormal()

local pa = a:getUserData()
local pb = b:getUserData()

if pa.sort == "player" then
	if coll:isTouching( ) then
	players[pa.id].canJump = true
	end
end

if pb.sort == "player" then
	if coll:isTouching( ) then
	players[pb.id].canJump = true
	end
end



end




function endContact(a, b, coll)

local pa = a:getUserData()
local pb = b:getUserData()

if pa.sort == "player" then
 players[pa.id].canJump = false
end

if pb.sort == "player" then
 players[pb.id].canJump = false
end
   
end

function preSolve(a, b, coll)
    
end

function postSolve(a, b, coll)
    
end 


function love.load()

	love.physics.setMeter(64) 
	world = love.physics.newWorld(0, 9.81*64, true) 
	world:setCallbacks( beginContact, endContact, preSolve, postSolve )
	objects = {} 



	newObject(0, 0, false, 16, 16)
	newObject(16, 0, false, 16, 16)
	newObject(32, 0, false, 16, 16)
	
	
  newObject(1280/2, 720-50/2, false, 1280, 50)
  newObject(0, 400, false, 50, 600)
  newObject(1280, 400, false, 50, 600)
  


  love.graphics.setBackgroundColor(104, 136, 248) 

	images = ImageLoader()


	grid = newGrid(love.graphics.getWidth(), love.graphics.getHeight())
	
	server = lube.server(7777)
	server:setCallback(onReceive, onConnect, onDisconnect)
	server:setHandshake("tomte")
end

function newPlayer(id, x, y)
	players[id] = {}
	players[id].ball = {}
	players[id].ball.body = love.physics.newBody(world, 650/3, 650/3, "dynamic")
	players[id].ball.shape = love.physics.newCircleShape(20)
	

	players[id].ball.fixture = love.physics.newFixture(players[id].ball.body, players[id].ball.shape, 1)
	
	local temp = {}
	temp.id = id
	temp.sort = "player"
	players[id].ball.fixture:setUserData(temp)
	
	players[id].color = {}
	players[id].color.r = math.random(255)
	players[id].color.g = math.random(255)
	players[id].color.b = math.random(255)
	players[id].id = id
	players[id].oldx = 0
	players[id].oldy = 0
	unsynced = true
	players[id].canJump = false
	
end


function newObject(x, y, dyn, w, h, dens, cr, cg, cb)
		
	nr_objects = nr_objects + 1
	local id = nr_objects
	if dyn then 
		dyn = "dynamic"
	else
		dyn = "static"
	end
	
	
	local dens = dens or 5
	
  objects[id] = {}
  objects[id].id = id
  objects[id].body = love.physics.newBody(world, x, y, dyn)
  objects[id].shape = love.physics.newRectangleShape(0, 0, w, h)
  objects[id].fixture = love.physics.newFixture(objects[id].body, objects[id].shape, 5) -- A higher density gives it more mass.
	
		local temp = {}
	temp.id = id
	temp.sort = "object"
	objects[id].fixture:setUserData(temp)
	
	objects[id].color = {}


	objects[id].color.r = cr or math.random(255)
	objects[id].color.g = cg or math.random(255)
	objects[id].color.b = cb or math.random(255)
	objects[id].old = {}
	objects[id].old[1] = 0
	objects[id].old[2] = 0
	unsynced = true
end



function onConnect(id)


	newPlayer(id, x, y)

end


unsynced = false

function onReceive(data, id)


	if string.find(data, "name") then
		local player_name = string.sub(data, "5")
		players[id].name = player_name
	end

	if data == 'unsynced' then 
		unsynced = true
	end
	
	
	if data == 'right' then 
		players[id].ball.body:applyForce(400, 0)
	elseif data == 'left' then 
		players[id].ball.body:applyForce(-400, 0)
	elseif data == 'up' then 
		players[id].ball.body:setPosition(1280/2, 0)
		players[id].ball.body:setLinearVelocity( 0, 0 )
	end
	
	if data == 'space' then 
	if players[id].canJump then

	  
	vx, vy = players[id].ball.body:getLinearVelocity( )
	players[id].ball.body:setLinearVelocity( vx, 0 )
	players[id].ball.body:applyLinearImpulse(0, -150)
		end
	end
	
	
end

function onDisconnect(id)
end





function drawToClient( i, x, y, r, sx, sy, ox, oy, kx, ky )
	local temp = {}
	temp.sort = "image"
	temp.i = i
	temp.x = x
	temp.y = y
	temp.r = r
	temp.sx = sx
	temp.sy = sy
	temp.ox = ox
	temp.oy = oy
	temp.kx = kx
	temp.ky = ky
	
	table.insert(dataToSend, temp)

	love.graphics.draw( images[i], x, y, r, sx, sy, ox, oy, kx, ky )
end
  


function love.update( dt )

	server:update(dt)

	world:update(dt) 
	
	if unsynced then 

		dataToSend = drawque
		dataToSend["sync"] = #drawque
		netsend = Tserial.pack(dataToSend)
		unsynced = false
	else
		
		dataToSend["sync"] = #drawque
		netsend = Tserial.pack(dataToSend)
		unsynced = true
	end
	
	
	if netsend == "}" then
		server:send("nothing to update")
	else
		server:send( netsend )
	end
	
	
	dataToSend = {}
	
	
end
	drawque = {}
	
function love.draw()

	for k, v in ipairs( players ) do
		
		local temp = {}
		temp.sort = "circle"
		temp.color = v.color
		temp.x = math.floor(v.ball.body:getX())
		temp.y = math.floor(v.ball.body:getY())
		temp.r = v.ball.shape:getRadius()
		temp.id = v.id

		if v.oldx == temp.x and v.oldy == temp.y then
		--
		else
			table.insert(dataToSend, temp)
			drawque[v.id] = temp
			
			v.oldx = temp.x
			v.oldy = temp.y 
		end
	end
	
  	for k, v in ipairs( objects ) do
		
		
		local temp = {}
		 
		temp.sort = "polygon"
		temp.id = v.id
		temp.color = v.color
		temp.pol = {}
		temp.pol[1],temp.pol[2],temp.pol[3],temp.pol[4],temp.pol[5],temp.pol[6],temp.pol[7],temp.pol[8] = v.body:getWorldPoints(v.shape:getPoints())
		
		
		for i, v in ipairs(temp.pol) do
			temp.pol[i] = math.floor(temp.pol[i])

		end
		

		
		if temp.pol[1] == v.old[1] and temp.pol[2] == v.old[2] then
		
		else
			table.insert(dataToSend, temp)
			v.old[1] = temp.pol[1]
			v.old[2] = temp.pol[2]

			drawque[v.id] = temp
			
		end
	
		
	end
	
		for i, v in ipairs(drawque) do
			if v.sort == "image" then
				love.graphics.draw( images[v.i], v.x, v.y, v.r, v.sx, v.sy, v.ox, v.oy, v.kx, v.ky )
			end
					
			if v.sort == "polygon" then
				love.graphics.setColor(v.color.r, v.color.g, v.color.b, 128)
				love.graphics.polygon("fill",unpack(v.pol) )
				love.graphics.setColor(0, 0, 0)
				love.graphics.polygon("line",unpack(v.pol) )
			end
			
			if v.sort == "circle" then
				love.graphics.setColor(v.color.r, v.color.g, v.color.b)
				love.graphics.circle("fill", v.x, v.y, v.r)
			end
		end
		
	grid:draw()

	local x,y = grid:snap(love.mouse.getPosition())
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle( "fill", x,y, 16,16 )
	
	love.graphics.setColor(255,0,0)
	if box.x then
		
		local tx,ty = grid:snap(love.mouse.getPosition( ))
		
		love.graphics.rectangle( "line", box.x, box.y, tx-box.x, ty-box.y )
	
	
	end
	if text then
	love.graphics.print(text, 10, 10)
	end

end



function love.mousereleased(x, y, button)

local mx,my = grid:snap(x,y)

	if button == "l" then
	
		local w = grid:getSize()
		local h = grid:getSize()
		newObject(mx + w/2, my + h/2, true, w, h)

	end
	
	if button == "r" then
		local w = grid:getSize()
		local h = grid:getSize()
		newObject(mx + w/2, my + h/2, false, w, h)
	end
end


box = {}

function love.keypressed( key )

	if key == 't' then
	print(" ")
	print(Tserial.pack(drawque))
	end
	
	if key == 'y' then
	print(" ")
	print(Tserial.pack(dataToSend))
	
	end
	
	if key == 'u' then
	print(" ")
	print("#drawque = ".. #drawque)
	print("#dataToSend = ".. #dataToSend)
	
	end
	
	if key == 'lshift' then
		box.x,box.y = grid:snap(love.mouse.getPosition( ))
		local tx,ty = grid:snap(love.mouse.getPosition( ))

	end
	
	
end

function love.keyreleased( key )
	if key == 'lshift' then
		local tx,ty = grid:snap(love.mouse.getPosition( ))

		box.w = box.x - tx
		box.h = box.y - ty
		
		print(box.x+(-box.w/2), box.y+(-box.h/2), -box.w, -box.h)
		newObject(box.x+(-box.w/2), box.y+(-box.h/2), false, -box.w, -box.h)
		box = {}
	end
end

function love.mousepressed(x, y, button)
	if button == "wu" then grid:up() end
	if button == "wd" then grid:down() end
end